/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookStaticDtoAuthorizer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookStaticDtoAuthorizer{}

// FacebookStaticDtoAuthorizer struct for FacebookStaticDtoAuthorizer
type FacebookStaticDtoAuthorizer struct {
	StaticKey *string `json:"staticKey,omitempty"`
	Label     *string `json:"label,omitempty"`
}

// NewFacebookStaticDtoAuthorizer instantiates a new FacebookStaticDtoAuthorizer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookStaticDtoAuthorizer() *FacebookStaticDtoAuthorizer {
	this := FacebookStaticDtoAuthorizer{}
	return &this
}

// NewFacebookStaticDtoAuthorizerWithDefaults instantiates a new FacebookStaticDtoAuthorizer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookStaticDtoAuthorizerWithDefaults() *FacebookStaticDtoAuthorizer {
	this := FacebookStaticDtoAuthorizer{}
	return &this
}

// GetStaticKey returns the StaticKey field value if set, zero value otherwise.
func (o *FacebookStaticDtoAuthorizer) GetStaticKey() string {
	if o == nil || IsNil(o.StaticKey) {
		var ret string
		return ret
	}
	return *o.StaticKey
}

// GetStaticKeyOk returns a tuple with the StaticKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookStaticDtoAuthorizer) GetStaticKeyOk() (*string, bool) {
	if o == nil || IsNil(o.StaticKey) {
		return nil, false
	}
	return o.StaticKey, true
}

// HasStaticKey returns a boolean if a field has been set.
func (o *FacebookStaticDtoAuthorizer) HasStaticKey() bool {
	if o != nil && !IsNil(o.StaticKey) {
		return true
	}

	return false
}

// SetStaticKey gets a reference to the given string and assigns it to the StaticKey field.
func (o *FacebookStaticDtoAuthorizer) SetStaticKey(v string) {
	o.StaticKey = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *FacebookStaticDtoAuthorizer) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookStaticDtoAuthorizer) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *FacebookStaticDtoAuthorizer) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *FacebookStaticDtoAuthorizer) SetLabel(v string) {
	o.Label = &v
}

func (o FacebookStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookStaticDtoAuthorizer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.StaticKey) {
		toSerialize["staticKey"] = o.StaticKey
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	return toSerialize, nil
}

type NullableFacebookStaticDtoAuthorizer struct {
	value *FacebookStaticDtoAuthorizer
	isSet bool
}

func (v NullableFacebookStaticDtoAuthorizer) Get() *FacebookStaticDtoAuthorizer {
	return v.value
}

func (v *NullableFacebookStaticDtoAuthorizer) Set(val *FacebookStaticDtoAuthorizer) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookStaticDtoAuthorizer) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookStaticDtoAuthorizer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookStaticDtoAuthorizer(val *FacebookStaticDtoAuthorizer) *NullableFacebookStaticDtoAuthorizer {
	return &NullableFacebookStaticDtoAuthorizer{value: val, isSet: true}
}

func (v NullableFacebookStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookStaticDtoAuthorizer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
